﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.DirectX.DirectSound;
using System.Diagnostics;
using System.Xml;


namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public const int REQUEST_START = 0x00;
        public const int REQUEST_STOP = 0x01;

        public Form vf;             // VideoForm
        public bool getVideo;
        private WaveFormat wF;              // Waveフォーマットの構造体
        private UdpClient receiveUdp;       // Udpクライアント
        private Thread thReceive, thPlay, htReq, thVideo;    // 受信スレッド、再生スレッド、HTTPリクエストスレッド、映像受信スレッド
        private long receivedData = 0;
        private long previousReceivedData = 0;
        private bool receiveFlag=false;     // 現在データを受信しているか
        private BinaryWriter bw;            // ファイル書き込みのためのクラス(？)
        private int portNum;                // 受信ポート番号

        ///// Form1の値を他のフォームから呼び出すための記述 /////
        private static Form1 _form1Instance;

        public static Form1 Form1Instance
        {
            get 
            { 
                return _form1Instance;
            }
            
            set
            {
                _form1Instance = value;
            }
        
        }


        public string dist_Camera {
            get { 
                return dist_HTTPREQ.Text;
            }

            set {
                dist_HTTPREQ.Text = value;
            }

        }
        //////////////////////////////////////////////////////


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ////////// 設定をxmlファイルから読み込み //////////
            string fPath = Application.ExecutablePath;
            fPath = fPath.Substring(0,fPath.LastIndexOf(@"\")+1);
            fPath = fPath + "setting_receive.xml";
            readSetting(fPath);
            /////////////////////////////////////////////////
            Form1.Form1Instance = this;


        }


        //// スレッドからフォームを更新するための処理 ////
        private delegate void D_UpdText();
        
        private void UpdText() {
            label1.Text = receivedData + "byte受信";
            label2.Text = previousReceivedData +"";
            label1.Update();
        }
        //
        //////////////////////////////////////////////////



        private void button1_Click(object sender, System.EventArgs e)
        {

            /////////// 設定をxmlファイルに保存 //////////
            string fPath = Application.ExecutablePath;
            fPath = fPath.Substring(0, fPath.LastIndexOf(@"\") + 1);
            fPath = fPath + "setting_receive.xml";

            writeSetting(fPath);

            /////////////////////////////////////////////

            //受信開始・停止の判定//
            if (receiveFlag == true){

                thPlay.Abort();          //再生スレッドを破棄する
                thReceive.Abort();       //受信スレッドを破棄する
                thVideo.Abort();         //映像受信スレッドを破棄する
                htReq.Abort();

                receiveUdp.Close();      //UdpClientを終了させる
                if (checkBox1.Checked == true)
                {
                    bw.Close();              //ファイルを閉じる
                }

                ////htReq = new Thread(delegate()   //カメラにChat終了のリクエストを送る 
                ////{
                ////    dist_Camera = dist_HTTPREQ.Text;
                ////    reqHTTP(dist_HTTPREQ.Text, REQUEST_STOP);
                ////});
                ////htReq.Start();

                checkBox1.Enabled = true; //ファイル保存の有無の変更を可能にする
                button1.Text = "受信";
                button2.Enabled = true;  //保存先の変更を可能にする
                port.Enabled = true; //ポート番号の入力を可能にする
                receiveFlag = false;    
                return;                  //受信終了なのでこれ以上は何もせずに終了する
            }else{

                portNum = int.Parse(port.Text);

                htReq = new Thread(delegate()  //カメラにChat開始のリクエストを送る
                {
                    dist_Camera = dist_HTTPREQ.Text;
                    reqHTTP(dist_HTTPREQ.Text,REQUEST_START);
                });
                htReq.Start();

                button2.Enabled = false;   //受信中は保存先の変更を禁止する
                port.Enabled = false;  //受信中はポート番号の変更を禁止する
                checkBox1.Enabled = false; //受信中はファイル保存の有無の変更を禁止する
                button1.Text = "受信停止";
                receiveFlag = true;
            }

            receivedData = 0;  //受信済みバイト数

            //Wavフォーマットの生成
            wF = new WaveFormat();

            wF.FormatTag = WaveFormatTag.Pcm;

            wF.Channels = (short)numericUpDown1.Value; //チャンネル数
            wF.SamplesPerSecond = (int)numericUpDown2.Value; //周波数
            wF.BitsPerSample = (short)numericUpDown3.Value;  //量子化ビット数

            wF.BlockAlign = (short)(wF.Channels * (wF.BitsPerSample / (short)8));
            wF.AverageBytesPerSecond = wF.BlockAlign * wF.SamplesPerSecond;         // 1秒あたりのバイト数

            //UDP Clientの生成
            receiveUdp = new UdpClient(portNum);
            IPEndPoint remoteEP = new IPEndPoint(IPAddress.Any, portNum);

            //ファイル名の指定
            string filePath = labelPath.Text;
            int num = 1;

            while (System.IO.File.Exists(filePath + @"received" + num + ".wav"))
            {   // ファイル番号を確定させる
                num = num + 1;
            };

            // 書き込むファイルを生成する //
            if (checkBox1.Checked == true) {
                bw = new BinaryWriter(new FileStream(filePath + @"received" + num +".wav", FileMode.Create));
            }

            // 音声ストリーム再生のための準備 //
            Device dev;
            dev = new Device();
            dev.SetCooperativeLevel(this, CooperativeLevel.Priority); // 再生の優先度を設定 //

            BufferDescription pbBD = new BufferDescription(); // 再生内容を指定 //
            pbBD.BufferBytes = wF.AverageBytesPerSecond*2; //バッファサイズの指定(とりあえず2秒分)
            pbBD.ControlVolume = true;  // ボリュームコントロールを可能にする
            pbBD.Format = wF;           // Wavフォーマットを指定
            pbBD.GlobalFocus = true;    // ウィンドウが非アクティブの場合でも音を再生する

            SecondaryBuffer pbB = new SecondaryBuffer(pbBD, dev); // 再生用のセカンダリバッファ
            pbB.Volume = 0;                     // ボリューム (dB値なので0が最大)

            int threadInterval = 5;            // Udp受信、音声再生スレッドの動作間隔 (ms)
            int pbOffset = 0;    
            int buffercount = 0;                // バッファしたデータの数
            int pbCount = 0;                    // 再生を停止するためのフラグ。再生するごとに増加、データ受信で0にクリア。一定値になると再生を停止する
            int bufferSize = 16;                // データをいくつバッファリングするか
            byte[] pbBytes={},initpbBytes={};   // バッファリング用の配列。initpbBytesは初期化用の配列
            bool thPlayStopped = true;          // 再生スレッドが停止(破棄ではない)したかどうかのフラグ



            //Udp受信スレッド(+ファイル保存スレッド)
            thReceive = new Thread(delegate()
            {
                while (true)
                {

                    byte[] bytes = receiveUdp.Receive(ref remoteEP); //Udp経由でデータ(bytes)を読み込み
                    pbCount = 0;    //データを受信したので、再生を止めるフラグをクリアする

                    //再生が一回止められたらそれまで蓄積していたバッファ(pbB)をクリアする。
                    if (thPlayStopped == true) {
                        pbBytes = initpbBytes;
                        buffercount = 0;
                        pbOffset = 0;
                        thPlayStopped = false;
                    }

                    // 取得したデータをバッファリングする //
                    if (buffercount >bufferSize){   //データが規定数に達した場合の処理
                            
                        pbB.Write(pbB.WritePosition, pbBytes, LockFlag.None); //SecondaryBufferにデータを書き込み
                        pbBytes = initpbBytes;      //バッファをクリア
                        buffercount = 0;            //カウントをクリア
    
                        if (checkBox1.Checked == true) //ファイルに書き出す設定になっている場合、受信データを書き出す
                        {
                            bw.Write(pbBytes);
                        }

                    } else {    //データが規定数以下の場合の処理
 
                        pbBytes = pbBytes.Concat(bytes).ToArray();  //バッファ(pbBytes)にUdpから読み込んだデータ(bytes)を追加
                        buffercount = buffercount + 1;                          //データ数をカウント
                    }

                    //初期バッファリングの量をカウント(再生を開始させるまでのディレイを設けるために用意)
                    pbOffset = pbOffset + bytes.Length;
                
                    previousReceivedData = bytes.Length;        // デバッグ表示用。一回でUdpから受信したバイト数
                    receivedData = receivedData + bytes.Length; // デバッグ表示用。合計受信バイト数
                    Invoke(new D_UpdText(UpdText));             // デバッグ表示用。フォーム上の数字をカウントアップさせる

                    Thread.Sleep(threadInterval);
                }
            });
            thReceive.Start();



            //音声再生スレッド
            thPlay = new Thread(delegate()
            {
                while (true)
                {

                    if (pbCount > bufferSize *4 )   //データが一定時間贈られてこない場合、再生を停止する
                    {
                        pbB.Stop();
                        thPlayStopped = true;   //再生が停止したフラグを立てる

                    }
                    else {
                        if (pbB.Status.Playing == false & pbOffset > pbBD.BufferBytes / 2)
                        {
                            pbB.Play(0, BufferPlayFlags.Default);
                        }
                        else
                        {
                            Thread.Sleep(threadInterval);
                        }
                    }

                    pbCount = pbCount + 1;

                }


            });
            thPlay.Start();



            //映像表示スレッド
            thVideo = new Thread(delegate()
            {
                //getMjpeg();
                while (true)
                {
                    updateVideo();
                    Thread.Sleep(200);
                }
            });
            thVideo.Start();

            
        }



        //HTTP Requestを発行する
        private void reqHTTP(string ipAddr,int type) {

            string url1;

            switch (type){
                case REQUEST_START:
                    url1 = "http://" + ipAddr + "/chat_start.php";
                    break;
                case REQUEST_STOP:
                    url1 = "http://" + ipAddr + "/chat_stop.php";
                    break;
                default:
                    url1 = "http://" + ipAddr + "/chat_start.php";
                    break;
            }

            HttpWebRequest hWebReq;
            hWebReq = (HttpWebRequest) HttpWebRequest.Create(url1);
            hWebReq.Method = "GET";
            hWebReq.UserAgent = "UDP Sound Receiver";
            hWebReq.ReadWriteTimeout = 5000;
            hWebReq.Timeout = 5000; //タイムアウト時間(ms)
            hWebReq.KeepAlive = true;

            Stream objStream;
            try
            {
               objStream = hWebReq.GetResponse().GetResponseStream();
            }
            catch (System.Net.WebException e){
                System.Diagnostics.Debug.WriteLine(e);            
            }
            return;
        }



        //ファイルの保存先を指定するダイアログを表示
        private void button2_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.ShowDialog();

            if (folderBrowserDialog1.SelectedPath != null) {
                labelPath.Text = folderBrowserDialog1.SelectedPath;
                string tmp = labelPath.Text;
               
                if (tmp.Length != 3) {
                    tmp = string.Concat(tmp, @"\");
                    labelPath.Text = tmp;
                } 

            }

        }


        // 周波数
        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            switch ((int)numericUpDown2.Value){
                case 8001:
                    numericUpDown2.Value = 16000;
                    break;
                case 16001:
                    numericUpDown2.Value = 22050;
                    break;
                case 22051:
                    numericUpDown2.Value = 44100;
                    break;
                case 44101:
                    numericUpDown2.Value = 48000;
                    break;
                case 47999:
                    numericUpDown2.Value = 44100;
                    break;
                case 44099:
                    numericUpDown2.Value = 22050;
                    break;
                case 22049:
                    numericUpDown2.Value = 16000;
                    break;
                case 15999:
                    numericUpDown2.Value = 8000;
                    break;
            }
        }


        // 設定ファイルの書き込み //
        private int writeSetting(string fileName) {

            XmlDocument doc = new XmlDocument();
            XmlDeclaration decla = doc.CreateXmlDeclaration("1.0", "UTF-8", null);
            XmlNode root = doc.CreateElement("setting");
            doc.AppendChild(decla);
            doc.AppendChild(root);
            XmlElement element = doc.CreateElement("PORT");
            element.InnerText = port.Text;
            root.AppendChild(element);
            element = doc.CreateElement("PATH");
            element.InnerText = labelPath.Text;
            root.AppendChild(element);
            element = doc.CreateElement("SAVEASFILE");
            if (checkBox1.Checked == true)
            {
                element.InnerText = "1";
            }
            else
            {
                element.InnerText = "0";
            }
            root.AppendChild(element);

            element = doc.CreateElement("CHANNELS");
            element.InnerText = numericUpDown1.Value.ToString();
            root.AppendChild(element);

            element = doc.CreateElement("FREQUENCY");
            element.InnerText = numericUpDown2.Value.ToString();
            root.AppendChild(element);

            element = doc.CreateElement("SAMPLES");
            element.InnerText = numericUpDown3.Value.ToString();
            root.AppendChild(element);

            element = doc.CreateElement("DIST_HTTPREQ");
            element.InnerText = dist_HTTPREQ.Text;
            root.AppendChild(element);

            doc.Save(fileName);

            return 0;
        }


        // 設定ファイルの読み込み
        private int readSetting(string fileName) {

            if (File.Exists(fileName) == true)
            {

                XmlDocument doc = new XmlDocument();
                doc.Load(fileName);
                XmlNode root = doc.DocumentElement;
                XmlNode xNode;

                xNode = root.SelectSingleNode("PORT");
                port.Text = ((XmlElement)xNode).InnerText;
            
                xNode = root.SelectSingleNode("PATH");
                labelPath.Text = ((XmlElement)xNode).InnerText;

                xNode = root.SelectSingleNode("SAVEASFILE");
                if (((XmlElement)xNode).InnerText == "1")
                {
                    checkBox1.Checked = true;
                }
                else
                {
                    checkBox1.Checked = false;
                }
                
                xNode = root.SelectSingleNode("CHANNELS");
                numericUpDown1.Value = decimal.Parse(((XmlElement)xNode).InnerText);
                
                xNode = root.SelectSingleNode("FREQUENCY");
                numericUpDown2.Value = decimal.Parse(((XmlElement)xNode).InnerText);
                
                xNode = root.SelectSingleNode("SAMPLES");
                numericUpDown3.Value = decimal.Parse(((XmlElement)xNode).InnerText);
                
                xNode = root.SelectSingleNode("DIST_HTTPREQ");
                dist_HTTPREQ.Text = ((XmlElement)xNode).InnerText;

            }else {
                return -1;
            }

            return 0;
        }

        // プログラム終了時の処理
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (receiveFlag == true) {
                thPlay.Abort();
                thReceive.Abort();
                thVideo.Abort();
                this.Dispose();
            }

        }


        // 画面をクリックするとJPEGとして保存
        private void pictureBox1_Click(object sender, EventArgs e)
        {
            string fPath;
            string postfix;
            string fileName;
            const int fileNum = 10; //保存可能なファイルの数

            // プログラムの実行パスを取得
            fPath = Application.ExecutablePath;
            fPath = fPath.Substring(0, fPath.LastIndexOf(@"\") + 1);

            // ファイルに付与する年月日時刻を取得
            postfix = string.Format("{0:0000}", DateTime.Now.Year) + string.Format("{0:00}", DateTime.Now.Month) +
                string.Format("{0:00}", DateTime.Now.Hour) + string.Format("{0:00}", DateTime.Now.Month) +
                string.Format("{0:00}", DateTime.Now.Minute) + string.Format("{0:00}", DateTime.Now.Second);

            fileName = "Saved_" + postfix + ".jpg";

            // ファイルが規定数ある場合、古い物を消す
            IEnumerable<string> files = Directory.GetFiles(fPath, "Saved_*");

            string[] fileList = files.ToArray();

            if (files.Count() >= fileNum)
            {
                System.IO.File.Delete(fileList[0]);
            }

            // 現在の表示をJpegとして保存
            pictureBox1.Image.Save(fPath + fileName, System.Drawing.Imaging.ImageFormat.Jpeg);
        }



        // 映像を更新する関数(Jpegを一枚ずつ取得する方法)
        private void updateVideo()
        {
            string url;
            string ipAddr = dist_HTTPREQ.Text;

            url = "http://" + ipAddr + "/cgi-bin/get_jpg.cgi";

            HttpWebRequest hWebReq;
            Stream objStream;
            WebResponse hWebRes;

            try
            {

                    hWebReq = (HttpWebRequest)HttpWebRequest.Create(url);
                    hWebReq.Method = "GET";
                    hWebReq.UserAgent = "UDP Sound Receiver";
                    hWebReq.ReadWriteTimeout = 5000;
                    hWebReq.Timeout = 2000; //タイムアウト時間(ms)
                    hWebReq.KeepAlive = true;
                    hWebReq.Credentials = new NetworkCredential("root", "password");
                    hWebRes = hWebReq.GetResponse();
                    objStream = hWebRes.GetResponseStream();
                    pictureBox1.Image = Image.FromStream(objStream);
                    Thread.Sleep(200);

            }
            catch (System.Net.WebException ex)
            {
                System.Diagnostics.Debug.WriteLine(ex);
                muteVideoScreen();
            }

        }



        ////// MotionJpegの映像を受け取る(うまくうごかないのでとりあえず封印)
        ////private void getMjpeg()
        ////{
        ////    string url;
        ////    string ipAddr = dist_HTTPREQ.Text;
        ////    //ipAddr = "root:password@" + ipAddr;
        ////    url = "http://" + ipAddr + "/cgi-bin/get_jpg.cgi";

        ////    HttpWebRequest hWebReq;


        ////    Stream objStream;
        ////    MemoryStream ms;
        ////    WebResponse hWebRes;

        ////    try
        ////    {

        ////        ms = new MemoryStream();
        ////        byte[] buffer = new byte[10240];

        ////        while (true)
        ////        {
        ////            hWebReq = (HttpWebRequest)HttpWebRequest.Create(url);
        ////            hWebReq.Method = "GET";
        ////            hWebReq.Credentials = new NetworkCredential("root", "password");
        ////            hWebReq.KeepAlive = true;
        ////            hWebReq.UserAgent = "UDP Sound Receiver";
        ////            hWebReq.ReadWriteTimeout = 5000;
        ////            hWebReq.Timeout = 5000; //タイムアウト時間(ms)
        ////            hWebReq.KeepAlive = true;
        ////            hWebRes = hWebReq.GetResponse();
        ////            objStream = hWebRes.GetResponseStream();

        ////            while (true)
        ////            {
        ////                int read = objStream.Read(buffer, 0, buffer.Length);

        ////                if (read > 0)
        ////                {
        ////                    ms.Write(buffer, 0, read);
        ////                }
        ////                else
        ////                {
        ////                    break;
        ////                }
        ////            }

        ////            pictureBox1.Image = Image.FromStream(ms);
        ////            Thread.Sleep(100);

        ////        }
        ////    }
        ////    catch (System.Net.WebException ex)
        ////    {
        ////        System.Diagnostics.Debug.WriteLine(ex);
        ////    }
        ////}



        // 映像画面を塗りつぶす
        private void muteVideoScreen(){
            Bitmap bmpdata = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics gra = Graphics.FromImage(bmpdata);
            gra.FillRectangle(Brushes.Blue, 0, 0, pictureBox1.Width, pictureBox1.Height);
            pictureBox1.Image = bmpdata;
        }


        // 履歴画面を表示する
        private void button3_Click(object sender, EventArgs e)
        {
            HistoryForm hF = new HistoryForm();
            hF.ShowDialog(); //履歴画面表示中は裏のフォームを触れないようにする
        }



    }
}
