﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class HistoryForm : Form
    {
        public HistoryForm()
        {
            InitializeComponent();
        }

        // 履歴画面が表示されたときの処理
        private void HistoryForm_Load(object sender, EventArgs e)
        {
            int thumWidth, thumHeight;  //サムネイルのサイズ
            string fPath = MainForm.Form1Instance.pathes.applicationPath;            // アプリケーションの実行パスを取得
            string[] images = System.IO.Directory.GetFiles(fPath, "Saved_*.jpg");    //

            Array.Sort(images);     // ファイル名順に並び替え

            thumWidth = 160;
            thumHeight =90;

            imageList1.ImageSize = new Size(thumWidth, thumHeight);
            imageList1.ColorDepth = ColorDepth.Depth24Bit;
            listView1.LargeImageList = imageList1;

            int j = 0;
            for (int i = 0; i < images.Length;i++ )
            {
                try
                {
                    Image org = Bitmap.FromFile(images[i]);　//ファイルからBMPイメージを取得
                    Image thumb = org.GetThumbnailImage(thumWidth, thumHeight, null, IntPtr.Zero); //BMPイメージからサムネイルを取得

                    imageList1.Images.Add(thumb);　// imageListにサムネイルイメージを貼り付け
                    string dateTime = System.IO.Directory.GetLastWriteTime(images[i]).ToString(); //ファイルの作成日時を取得
                    listView1.Items.Add(images[i], dateTime, j); //ListViewの要素として日付を記入
                    j = j + 1;

                    org.Dispose();
                    thumb.Dispose();
                }
                catch { 
                    //ファイルが破損しているなどで例外を出力した場合、そのファイルは無視する

                }
            }
        }


        // 履歴の画像をクリックしたときの処理(JPGに関連付けられたプログラムが起動する)
        private void listView1_Click(object sender, EventArgs e)
        {
            // ListView上でファイルが１つ選ばれたときにだけファイル名を渡す
            if (listView1.SelectedItems.Count ==1)
            {
                string obj = listView1.SelectedItems[0].Name;   // ListViewで選択されている項目のkeyを取得
                //テスト(JPGを関連付け起動させる)
                System.Diagnostics.Process.Start(obj);            
            }
        }

    }
}
