﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.IO;

namespace WindowsFormsApplication1
{
    class JSON_Commands
    {
        ///// JSONデータ構造宣言 ///////////////

        ///// パンチルタコントロール用送信データ /////
        [DataContract]
        public class PTCtrlMain
        {
            [DataMember(Order = 0, Name = "Command")]   public String Command { get; set; }
            [DataMember(Order = 1, Name = "Params")]    public PTCtrl_Params Params { get; set; }
        }
        [DataContract]
        public class PTCtrl_Params
        {
            [DataMember(Order = 0, Name = "Cmd")]       public int Cmd { get; set; }
            [DataMember(Order = 1, Name = "Pan")]       public int Pan { get; set; }
            [DataMember(Order = 2, Name = "Tilt")]      public int Tilt { get; set; }
        }


        /////// ズームコントロール用送信データ(一回送ると一定量だけ動く) ////////
        [DataContract]
        public class ZoomCtrlMain
        {
            [DataMember(Order = 0, Name = "Command")]   public String Command { get; set; }
            [DataMember(Order = 1, Name = "Params")]    public ZoomCtrl_Params Params { get; set; }
        }
        [DataContract]
        public class ZoomCtrl_Params
        {
            [DataMember(Order = 0, Name = "Zoom")]      public int Zoom { get; set; }
            [DataMember(Order = 1, Name = "NeedEnd")]   public bool NeedEnd { get; set; }
        }


        /////// ズームコントロール用データ(ズーム位置で指定) /////
        [DataContract]
        public class ZoomPositionMain
        {
            [DataMember(Order = 0, Name = "Command")]   public String Command { get; set; }
            [DataMember(Order = 1, Name = "Params")]    public ZoomPosition_Params Params { get; set; }
        }
        [DataContract]
        public class ZoomPosition_Params
        {
            [DataMember(Order = 0, Name = "DeciZoomPosition")]  public int DeciZoomPosition { get; set; }
            [DataMember(Order = 1, Name = "Speed")]             public int Speed { get; set; }
            [DataMember(Order = 2, Name = "NeedEnd")]           public bool NeedEnd { get; set; }
        }


        ///// パンチルトズームの現在情報を取得 /////////
        [DataContract]
        public class PTZ_Position
        {
            [DataMember(Order = 0, Name = "Requested")]         public string Requested { get; set; }
            [DataMember(Order = 0, Name = "Result")]            public string Result { get; set; }
            [DataMember(Order = 0, Name = "Data")]              public PTZ_Position_Data Data { get; set; }
        }
        [DataContract]
        public class PTZ_Position_Data
        {
            [DataMember(Order = 0, Name = "PantiltValid")]      public bool PantiltValid { get; set; }
            [DataMember(Order = 1, Name = "PanPosition")]       public int PanPosition { get; set; }
            [DataMember(Order = 2, Name = "TiltPosition")]      public int TiltPosition { get; set; }
            [DataMember(Order = 3, Name = "DeciZoomPosition")]  public int DeciZoomPosition { get; set; }
        }


        ///// カメラの情報を受け取る  ///////////////
        [DataContract]
        public class Cam_Feat
        {
            [DataMember(Order = 0, Name = "Requested")]             public string Requested { get; set; }
            [DataMember(Order = 1, Name = "Result")]                public string Result { get; set; }
            [DataMember(Order = 2, Name = "Data")]                  public Cam_Feat_Data Data { get; set; }
        }
        [DataContract]
        public class Cam_Feat_Data
        {
            [DataMember(Order = 0, Name = "CamVer")]                public int CamVer { get; set; }
            [DataMember(Order = 1, Name = "IsAdmin")]               public string IsAdmin { get; set; }
            [DataMember(Order = 2, Name = "HasMechaPanTilt")]       public bool HasMechaPanTilt { get; set; }
            [DataMember(Order = 3, Name = "MechaPanMax")]           public int MechaPanMax { get; set; }
            [DataMember(Order = 4, Name = "MechaPanMin")]           public int MechaPanMin { get; set; }
            [DataMember(Order = 5, Name = "MechaTiltMax")]          public int MechaTiltMax { get; set; }
            [DataMember(Order = 6, Name = "MechaTiltMin")]          public int MechaTiltMin { get; set; }
            [DataMember(Order = 7, Name = "MechaSpeedMax")]         public int MechaSpeedMax { get; set; }
            [DataMember(Order = 8, Name = "MechaSpeedMin")]         public int MechaSpeedMin { get; set; }
            [DataMember(Order = 9, Name = "DeciZoomMax")]           public int DeciZoomMax { get; set; }
            [DataMember(Order = 10, Name = "DeciZoomMin")]          public int DeciZoomMin { get; set; }
            [DataMember(Order = 11, Name = "HasDegitalPanTilt")]    public bool HasDegitalPanTilt { get; set; }
            [DataMember(Order = 12, Name = "DegitalXMax")]          public int DegitalXMax { get; set; }
            [DataMember(Order = 13, Name = "DegitalXMin")]          public int DegitalXMin { get; set; }
            [DataMember(Order = 14, Name = "DegitalYMax")]          public int DegitalYMax { get; set; }
            [DataMember(Order = 15, Name = "DegitalYMin")]          public int DegitalYMin { get; set; }
            [DataMember(Order = 16, Name = "DigitalDeciZoomMax")]   public int DigitalDeciZoomMax { get; set; }
            [DataMember(Order = 17, Name = "DigitalDeciZoomMin")]   public int DigitalDeciZoomMin { get; set; }
            [DataMember(Order = 18, Name = "DigitalPTZSpeedMax")]   public int DigitalPTZSpeedMax { get; set; }
            [DataMember(Order = 19, Name = "DigitalPTZSpeedMin")]   public int DigitalPTZSpeedMin { get; set; }
            [DataMember(Order = 21, Name = "Mpeg2tsSize")]          public string Mpeg2tsSize { get; set; }
            [DataMember(Order = 22, Name = "FrameRate")]            public string FrameRate { get; set; }
            [DataMember(Order = 23, Name = "VideoSignalType")]      public string VideoSignalType { get; set; }
        }


        ///// カメラの状態を受け取る  ///////////////
        [DataContract]
        public class CamStatus {
            [DataMember(Order = 0, Name = "Requested")]             public string Requested { get; set; }
            [DataMember(Order = 1, Name = "Result")]                public string Result { get; set; }
            [DataMember(Order = 2, Name = "Data")]                  public CamStatus_Data Data { get; set; }
        }       
        [DataContract]
        public class CamStatus_Data
        {
            [DataMember (Order =0, Name = "BatteryLevel")]          public int BatteryLevel { get; set; }
            [DataMember(Order = 1, Name = "AcExist")]               public bool AcExist { get; set; }
            [DataMember(Order = 2, Name = "SdcardExist")]           public string SdcardExist { get; set; }
            [DataMember(Order = 3, Name = "SdcardRemains")]         public string SdcardRemains { get; set; }
            [DataMember(Order = 4, Name = "CamMotion")]             public string CamMotion { get; set; }
            [DataMember(Order = 5, Name = "IsFocusAuto")]           public bool IsFocusAuto { get; set; }
            [DataMember(Order = 6, Name = "HasMotionJpegRes")]      public bool HasMotionJpegRes { get; set; }
            [DataMember(Order = 7, Name = "HasLpcmRes")]            public bool HasLpcmRes { get; set; }
            [DataMember(Order = 8, Name = "HasMpeg2tsRes")]         public bool HasMpeg2tsRes { get; set; }
            [DataMember(Order = 9, Name = "CamMode")]               public string CamMode { get; set; }
            [DataMember(Order = 10, Name = "CamIndexVideoFormat")]  public string CamIndexVideoFormat { get; set; }
            [DataMember(Order = 11, Name = "ZoomLevel")]            public int ZoomLevel { get; set; }
            [DataMember(Order = 12, Name = "IsSleepImageSensor")]   public bool IsSleepImageSensor { get; set; }
        }


        ///// カメラの状態(明るさ補正など）を受け取る //////////
        [DataContract]
        public class CamAutoStatus {
            [DataMember(Order = 0, Name = "Requested")]         public string Requested { get; set; }
            [DataMember(Order = 1, Name = "Result")]            public string Result { get; set; }
            [DataMember(Order = 2, Name = "Data")]              public CamAutoStatus_Data Data { get; set; }
        }
        [DataContract]
        public class CamAutoStatus_Data{
            [DataMember(Order = 0, Name = "DIS")]               public string DIS { get; set;}
            [DataMember(Order = 1, Name = "BrightnessLevel")]   public string BrightnessLevel { get; set; }
            [DataMember(Order = 2, Name = "ShutterSpeed")]      public string ShutterSpeed { get; set; }
            [DataMember(Order = 3, Name = "WhiteBalance")]      public string WhiteBalance { get; set; }
            [DataMember(Order = 4, Name = "VideoQuality")]      public string VideoQuality { get; set; }
            [DataMember(Order = 5, Name = "DateRecPosition")]   public string DateRecPosition { get; set; }
            [DataMember(Order = 6, Name = "IsDateRecSec")]      public string IsDateRecSec { get; set; }
            [DataMember(Order = 7, Name = "Tally")]             public string Tally { get; set; }
            [DataMember(Order = 8, Name = "Light")]             public string Light { get; set; }
            [DataMember(Order = 9, Name = "Focus")]             public string Focus { get; set; }
            [DataMember(Order = 10, Name = "FrameInRec")]       public string FrameInRec { get; set; }
            [DataMember(Order = 11, Name = "GainUp")]           public string GainUp { get; set; }
        }


        ///// カメラのコントロールを行う(REC/STOP、フォーカス、ズームなどある模様) //////////
        [DataContract]
        public class SetCamCtrl {
            [DataMember(Order =0, Name="Command")]              public string Command { get; set; }
            [DataMember(Order = 1, Name = "Params")]            public SetCamCtrl_Params Params { get; set; }
        }
        [DataContract]
        public class SetCamCtrl_Params
        {
            [DataMember(Order = 0, Name = "Ctrl")]              public string Ctrl { get; set; }
        }


        ///// カメラのオート調整を行う(オートフォーカス・マニュアルフォーカスなど) //////////
        [DataContract]
        public class SetCamAutoCtrl {
            [DataMember(Order = 0, Name = "Command")]           public string Command { get; set; }
            [DataMember(Order = 1, Name = "Params")]            public string Params { get; set; }
        }



        ////////////////// 入力データ -> byte配列(JSON構造データ)の変換関数 //////////////////////////

        // SetCamCtrlコマンドのJSON構造データをByte配列で返す関数
        public byte[] SetCAMCtrl(string Ctrl) {
            byte[] sendBytes = { };
            SetCamCtrl pc = new SetCamCtrl();
            SetCamCtrl_Params pc_prm = new SetCamCtrl_Params();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(SetCamCtrl));
            MemoryStream ms = new MemoryStream();

            // JSONデータの作成
            pc.Command = constClass.CMD_CAM_CTRL;
            pc_prm.Ctrl = Ctrl;
            pc.Params = pc_prm;
            serializer.WriteObject(ms, pc); // JSON形式でメモリストリームに変換
            sendBytes = ms.ToArray();       // memoryStreamからバイト配列に変換

            pc = null;
            pc_prm = null;
            return sendBytes;
        
        }

        // SetCamAutoコマンドのJSON構造データをByte配列で返す関数 (.net標準のJSON Serializerでは扱えなかったため、強引にバイト配列として作成)
        public byte[] SetCAMAutoCtrl(string Ctrl, string parm) {

            string jsonString = "{" + "\"Command\":\"" + constClass.CMD_CAM_AUTO_CTRL + "\"," 
                + "\"Params\":" + "{\"" + Ctrl + "\":\"" + parm + "\"}}";
            byte[] sendBytes = Encoding.ASCII.GetBytes(jsonString);
            
            return sendBytes;
        }


        // SetPTCtrlコマンドのJSON構造データをByte配列で返す関数
        public byte[] SetPTCtrl(int Cmd = 0, int Pan = 0, int Tilt = 0)
        {
            Byte[] sendBytes = { };
            PTCtrlMain pt = new PTCtrlMain();
            PTCtrl_Params pt_prm = new PTCtrl_Params();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(PTCtrlMain)); //
            MemoryStream ms = new MemoryStream();  //  

            // JSONデータを作成
            pt.Command = constClass.CMD_PAN_TILT;
            pt_prm.Cmd = Cmd;
            pt_prm.Pan = Pan;
            pt_prm.Tilt = Tilt;
            pt.Params = pt_prm;
            serializer.WriteObject(ms, pt);
            sendBytes = ms.ToArray();             // memoryStreamからバイト配列に変換

            pt = null;
            pt_prm = null;
            return sendBytes;
        }


        // SetZoomPositionコマンドのJSON構造データをByte配列で返す関数
        public byte[] SetZoomPosition(int DeciZoomPosition = 10, int Speed = 0)
        {
            Byte[] sendBytes = { };
            ZoomPositionMain zp = new ZoomPositionMain();
            ZoomPosition_Params zp_prm = new ZoomPosition_Params();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(ZoomPositionMain)); //
            MemoryStream ms = new MemoryStream();  // 

            // JSONデータを作成
            zp.Command = constClass.CMD_ZOOM_POSITION;
            zp_prm.DeciZoomPosition = DeciZoomPosition;
            zp_prm.Speed = Speed;
            zp_prm.NeedEnd = true;
            zp.Params = zp_prm;
            serializer.WriteObject(ms, zp);
            sendBytes = ms.ToArray();
            zp = null;
            zp_prm = null;
            return sendBytes;
        }


        // SetZoomCtrlコマンドのJSON構造データをByte配列で返す関数
        public byte[] SetZoomCtrl(int Zoom = 0)
        {
            Byte[] sendBytes = { };
            ZoomCtrlMain zc = new ZoomCtrlMain();
            ZoomCtrl_Params zc_prm = new ZoomCtrl_Params();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(ZoomCtrlMain)); //
            MemoryStream ms = new MemoryStream();  // 

            // JSONデータを作成
            zc.Command = constClass.CMD_ZOOM;
            zc_prm.Zoom = Zoom;
            zc_prm.NeedEnd = true;
            zc.Params = zc_prm;
            serializer.WriteObject(ms, zc);
            sendBytes = ms.ToArray();
            zc = null;
            zc_prm = null;
            return sendBytes;
        }


        ////////////////// レスポンスデータ(byte配列) -> JSON -> 構造体の変換関数 //////////////////////////

        // getCamStatusの応答メッセージ(byte配列)を構造体に変換する関数
        public Cam_Status getResponseCamStatus(byte[] in_, int length) 
        {

            Cam_Status cSD = new Cam_Status();
            MemoryStream ms = new MemoryStream();

            ms.Write(in_, 0, length);
            ms.Seek(0, SeekOrigin.Begin);                     // 読み出し位置を先頭に戻す
            var serializer = new DataContractJsonSerializer(typeof(CamStatus));
            var rcv = serializer.ReadObject(ms) as CamStatus;  // ストリーム(JSON形式)のデータからオブジェクトに変換
            var dd = rcv.Data as CamStatus_Data;               // 受信したJSONデータからDataフィールド以下を取得

            if (dd != null)
            {
                cSD.BatteryLevel = dd.BatteryLevel;                 // バッテリー
                cSD.AcExist = dd.AcExist;                           // ACアダプタが刺さっているか
                cSD.SdcardExist = dd.SdcardExist;                   // SDカードの状態(あり、なし、ライトプロテクト)
                cSD.SdcardRemains = dd.SdcardRemains;               // SDカード残量
                cSD.CamMotion = dd.CamMotion;                       // ?
                cSD.IsFocusAuto = dd.IsFocusAuto;                   // オートフォーカスかどうか
                cSD.HasMotionJpegRes = dd.HasMotionJpegRes;         // ?
                cSD.HasLpcmRes = dd.HasLpcmRes;                     // ?
                cSD.HasMpeg2tsRes = dd.HasMpeg2tsRes;               // ?
                cSD.CamMode = dd.CamMode;                           // ?
                cSD.CamIndexVideoFormat = dd.CamIndexVideoFormat;   // ?
                cSD.ZoomLevel = dd.ZoomLevel;                       // ズームと思われるがちゃんと帰ってこない
                cSD.IsSleepImageSensor = dd.IsSleepImageSensor;     // センサーがスリープしているかどうか
            }

            return cSD;
        }


        // getCamAutoStatusの応答メッセージ(byte配列)を構造体に変換する関数
        public Cam_AutoStatus getResponseCamAutoStatus(byte[] in_, int length) {

            Cam_AutoStatus cAS = new Cam_AutoStatus();
            MemoryStream ms = new MemoryStream();

            ms.Write(in_, 0, length);
            ms.Seek(0, SeekOrigin.Begin);                     // 読み出し位置を先頭に戻す
            var serializer = new DataContractJsonSerializer(typeof(JSON_Commands.CamAutoStatus));
            var rcv = serializer.ReadObject(ms) as JSON_Commands.CamAutoStatus;  // ストリーム(JSON形式)のデータからオブジェクトに変換

            var dd = rcv.Data as JSON_Commands.CamAutoStatus_Data;               // 受信したJSONデータからDataフィールド以下を取得

            if (dd != null)
            {
                cAS.BrightnessLevel = dd.BrightnessLevel;
                cAS.DateRecPosition = dd.DateRecPosition;
                cAS.DIS = dd.DIS;
                cAS.Focus = dd.Focus;
                cAS.FrameInRec = dd.FrameInRec;
                cAS.GainUp = dd.GainUp;
                cAS.IsDateRecSec = dd.IsDateRecSec;
                cAS.Light = dd.Light;
                cAS.ShutterSpeed = dd.ShutterSpeed;
                cAS.Tally = dd.Tally;
                cAS.VideoQuality = dd.VideoQuality;
                cAS.WhiteBalance = dd.WhiteBalance;
            }

            return cAS;
        }


        // getCamFeatureの応答メッセージ(byte配列)を構造体に変換する関数
        public Cam_Feature_Data getResponseCamFeature(byte[] in_, int length) {

            Cam_Feature_Data cFD = new Cam_Feature_Data();
            MemoryStream ms = new MemoryStream();

            ms.Write(in_, 0, length);
            ms.Seek(0, SeekOrigin.Begin);                     // 読み出し位置を先頭に戻す
            var serializer = new DataContractJsonSerializer(typeof(Cam_Feat));
            var rcv = serializer.ReadObject(ms) as Cam_Feat;  // ストリーム(JSON形式)のデータからオブジェクトに変換
            var dd = rcv.Data as Cam_Feat_Data;               // 受信したJSONデータからDataフィールド以下を取得

            if (dd != null)
            {
                cFD.CamVer = dd.CamVer;
                cFD.DeciZoomMax = dd.DeciZoomMax;                  cFD.DeciZoomMin = dd.DeciZoomMin;                // 最大/最小ズーム倍率
                cFD.DegitalXMax = dd.DegitalXMax;                  cFD.DegitalXMin = dd.DegitalXMin;                // デジタルX ? データがこんな感じで帰ってきたので(LS1用？)
                cFD.DegitalYMax = dd.DegitalYMax;                  cFD.DegitalYMin = dd.DegitalYMin;                // デジタルY ? データがこんな感じで帰ってきたので(LS1用？)
                cFD.DigitalDeciZoomMax = dd.DigitalDeciZoomMax;    cFD.DigitalDeciZoomMin = dd.DigitalDeciZoomMin;  // 最大/最小デジタルズーム?
                cFD.DigitalPTZSpeedMax = dd.DigitalPTZSpeedMax;    cFD.DigitalPTZSpeedMin = dd.DigitalPTZSpeedMin;  // デジタル?のパンチルトスピード(LS1用?) 
                cFD.FrameRate = dd.FrameRate;                                                                       // フレームレート(おそらくMotionJpeg用)
                cFD.HasDegitalPanTilt = dd.HasDegitalPanTilt;      cFD.HasMechaPanTilt = dd.HasMechaPanTilt;        // デジタルパンチルトがあるか？、メカパンチルトがあるか
                cFD.IsAdmin = dd.IsAdmin;                                                                           // 管理者かどうか? (何に使う?)
                cFD.MechaPanMax = dd.MechaPanMax;                  cFD.MechaPanMin = dd.MechaPanMin;                // パンの最小/最大(角度?)
                cFD.MechaSpeedMax = dd.MechaSpeedMax;              cFD.MechaSpeedMin = dd.MechaSpeedMin;            // スピード
                cFD.MechaTiltMax = dd.MechaTiltMax;                cFD.MechaTiltMin = dd.MechaTiltMin;              // チルトの最小/最大(角度?)
                cFD.Mpeg2tsSize = dd.Mpeg2tsSize;                                                                   // Mpeg2tsのサイズ
                cFD.VideoSignalType = dd.VideoSignalType;                                                           // ビデオ信号の種類(用途不明)
            }

            return cFD;        
        }


        // getPTZの応答メッセージ(byte配列)を構造体に変換する関数
        public PresetData_without_Name getResponsePTZ(byte[] in_, int length) {
            
            PresetData_without_Name preData = new PresetData_without_Name();
            MemoryStream ms = new MemoryStream();

            ms.Write(in_, 0, length);
            ms.Seek(0, SeekOrigin.Begin);                     // 読み出し位置を先頭に戻す

            var serializer = new DataContractJsonSerializer(typeof(PTZ_Position));
            var rcv = serializer.ReadObject(ms) as PTZ_Position;  // ストリーム(JSON形式)のデータからオブジェクトに変換
            var dd = rcv.Data as PTZ_Position_Data;               // 受信したJSONデータからDataフィールド以下を取得  

            if (dd != null)
            {
                preData.PanTiltValid = dd.PantiltValid;
                preData.PanPosition = dd.PanPosition;
                preData.TiltPosition = dd.TiltPosition;
                preData.DeciZoomPosition = dd.DeciZoomPosition;
            }
            else
            {
                preData.PanTiltValid = false;
                preData.PanPosition = 0;
                preData.TiltPosition = 0;
                preData.DeciZoomPosition = -1;
            }

            return preData;
        }

    }




}
