﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;

namespace WindowsFormsApplication1
{
    class camControl
    {

        // REC開始コマンドの送信
        public void postREC_START() {            
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postCtrlCommand(constClass.Ctrl_RecStart,ipAddr,port,cookie,useProxy);
        }

        // REC停止コマンドの送信
        public void postREC_STOP() {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postCtrlCommand(constClass.Ctrl_RecStop, ipAddr, port, cookie, useProxy);
        }

        // オートフォーカスコマンドの送信
        public void postFOCUS_AUTO() {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postAutoCtrlCommand(constClass.AutoCtrl_Focus, constClass.AutoCtrl_Focus_Auto, ipAddr, port, cookie, useProxy);
        }

        // マニュアルフォーカスコマンドの送信
        public void postFOCUS_MANUAL() {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postAutoCtrlCommand(constClass.AutoCtrl_Focus, constClass.AutoCtrl_Focus_Manual, ipAddr, port, cookie, useProxy);
        }

        // Focus調整(Near側)
        public void postFOCUS_NEAR() {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postCtrlCommand(constClass.Ctrl_FocusNear, ipAddr, port, cookie, useProxy);
        }

        // Focus調整停止(Near側)
        public void postFOCUS_NEAR_STOP() {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postCtrlCommand(constClass.Ctrl_FocusNearRelease, ipAddr, port, cookie, useProxy);
        }

        // Focus調整(Far側)
        public void postFOCUS_FAR() {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postCtrlCommand(constClass.Ctrl_FocusFar, ipAddr, port, cookie, useProxy);    
        }

        // Focus調整停止(Far側)
        public void postFOCUS_FAR_STOP()
        {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postCtrlCommand(constClass.Ctrl_FocusFarRelease, ipAddr, port, cookie, useProxy);
        }

        // その他(明るさ補正など)の送信関数
        public void postAutoCtrlCommand(string cmd, string parm) {
            int cam = MainForm.Form1Instance.selectedCamera;
            string ipAddr = MainForm.Form1Instance.cameraSettings[cam].ipAddress;
            string port = MainForm.Form1Instance.cameraSettings[cam].portNumber;
            bool useProxy = MainForm.Form1Instance.cameraSettings[cam].useProxy;
            CookieContainer cookie = MainForm.Form1Instance.cookieContainers[cam];

            postAutoCtrlCommand(cmd, parm, ipAddr, port, cookie, useProxy); 
            
        }

        // SetCamCtrlコマンドの送信関数
        private void postCtrlCommand(string cmd, string ipAddr, string port, CookieContainer cookie_, bool useProxy) 
        {
            Thread thSession = new Thread(delegate()
            {
                httpClass htC = new httpClass();
                JSON_Commands jsonC = new JSON_Commands();
                htC.postStream("http://" + ipAddr + ":" + port + httpClass.URL_SEND_COMMAND, jsonC.SetCAMCtrl(cmd), cookie_, useProxy);
            });
            thSession.Start();
        }

        // SetCamAutoCtrlコマンドの送信関数
        private void postAutoCtrlCommand(string cmd, string parm, string ipAddr, string port, CookieContainer cookie_, bool useProxy)
        {
            //Thread thSession = new Thread(delegate() // 送信終わりを待ってから次のコマンドを送るようにするために、あえてスレッドにはしない
            //{
                httpClass htC = new httpClass();
                JSON_Commands jsonC = new JSON_Commands();
                Console.WriteLine(Encoding.ASCII.GetString(jsonC.SetCAMAutoCtrl(cmd,parm)));
                htC.postStream("http://" + ipAddr + ":" + port + httpClass.URL_SEND_COMMAND, jsonC.SetCAMAutoCtrl(cmd,parm), cookie_, useProxy);
            //});
            //thSession.Start();
        }



    }
}
