﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1
{
    class constClass
    {
        // 初期設定関係
        public const string DEFAULT_USERNAME = "root";
        public const string DEFAULT_PASSWORD = "password";
        public const string DEFAULT_IPADDRESS = "";
        public const string DEFAULT_PORT = "80";
        public const bool DEFAULT_USE_PROXY = false;
        public const bool DEFAULT_INVERSE_PICTURE = false;
        public const bool DEFAULT_PLAY_SOUND = false;
        public const bool DEFAULT_OVERLAY_STRING = false;
        public const string DEFAULT_OVERLAY_STRING_DATA = "";
        public const bool DEFAULT_RECEIVE_FLAG = false;
        public const int DEFAULT_SELECTED_CAMERA = 0;

        // カメラの数
        public const int MAX_NUM_OF_CAMERA = 4;

        // カメラ1台あたりの最大同時接続数
        public const int MAX_HTTP_CONNECTION_PER_CAMERA = 8;    // セッション更新、映像、音声、コントロール、プリセット、カメラ状態 etc...

        // HTTPの最大同時接続数
        public const int MAX_HTTP_CONNECTION = MAX_NUM_OF_CAMERA * MAX_HTTP_CONNECTION_PER_CAMERA;  // カメラ台数が増えてくると厳しいので

        // カメラコントロール関係
        public const string CMD_CAM_CTRL = "SetCamCtrl";

        public const string Ctrl_WideBegin1 = "WideBegin1";
        public const string Ctrl_WideBegin2 = "WideBegin2";
        public const string Ctrl_WideBegin3 = "WideBegin3";
        public const string Ctrl_WideEnd = "WideEnd";
        public const string Ctrl_TeleBegin1 = "TeleBegin1";
        public const string Ctrl_TeleBegin2 = "TeleBegin2";
        public const string Ctrl_TeleBegin3 = "TeleBegin3";
        public const string Ctrl_TeleEnd = "TeleEnd";
        public const string Ctrl_RecStart = "RecStart";
        public const string Ctrl_RecStop = "RecStop";
        public const string Ctrl_FocusNear = "FocusNear";
        public const string Ctrl_FocusNearRelease = "ForcusNearRelease";
        public const string Ctrl_FocusFar = "FocusFar";
        public const string Ctrl_FocusFarRelease = "FocusFarRelease";        

        // オートコントロール関係
        public const string CMD_CAM_AUTO_CTRL = "SetCamAutoCtrl";

        public const string AutoCtrl_Focus = "Focus";
        public const string AutoCtrl_Focus_Auto = "AUTO";
        public const string AutoCtrl_Focus_Manual = "MANUAL";

        public const string AutoCtrl_Light = "Light";
        public const string AutoCtrl_Light_Auto = "AUTO";
        public const string AutoCtrl_Light_On = "ON";
        public const string AutoCtrl_Light_Off = "OFF";

        public const string AutoCtrl_DateREC = "DateRecPosition";
        public const string AutoCtrl_DateREC_Off = "OFF";
        public const string AutoCtrl_DateREC_UR = "UPPER_RIGHT";
        public const string AutoCtrl_DateREC_LR = "LOWER_RIGHT";
        public const string AutoCtrl_DateREC_UL = "UPPER_LEFT";
        public const string AutoCtrl_DateREC_LL = "LOWER_LEFT";

        // パンチルト関係
        public const string CMD_PAN_TILT = "SetPTCtrl";
        public const int CMD_PAN_STOP = 9;
        
        public const int CMD_PAN_LEFT_MIN = -2;
        public const int CMD_PAN_LEFT_MID = -3;
        public const int CMD_PAN_LEFT_HIG = -4;
        public const int CMD_PAN_LEFT_HI2 = -6;
        public const int CMD_PAN_LEFT_MAX = -8;

        public const int CMD_PAN_RIGHT_MIN = 2;
        public const int CMD_PAN_RIGHT_MID = 3;
        public const int CMD_PAN_RIGHT_HIG = 4;
        public const int CMD_PAN_RIGHT_HI2 = 6;
        public const int CMD_PAN_RIGHT_MAX = 8;

        public const int CMD_TILT_STOP = 19;
        public const int CMD_TILT_STOP2 = -19;

        public const int CMD_TILT_UP_MIN = 11;
        public const int CMD_TILT_UP_MID = 12;
        public const int CMD_TILT_UP_HIG = 13;
        public const int CMD_TILT_UP_HI2 = 14;
        public const int CMD_TILT_UP_MAX = 15;

        public const int CMD_TILT_DOWN_MIN = -11;
        public const int CMD_TILT_DOWN_MID = -12;
        public const int CMD_TILT_DOWN_HIG = -13;
        public const int CMD_TILT_DOWN_HI2 = -14;
        public const int CMD_TILT_DOWN_MAX = -15;

        public const int PAN_SPEED_STEP = 2;    // パッドで操作するときのPANのステップ
        public const int TILT_SPEED_STEP = 2;   // パッドで操作するときのTILTのステップ

        public const int CMD_PAN_TILT_ABSOLUTE = 0;

        // ズーム関係
        public const string CMD_ZOOM = "SetZoomCtrl";
        public const int CMD_T_ZOOM_MAX = -3;
        public const int CMD_W_ZOOM_MAX = 3;
        public const int CMD_ZOOM_STOP = 0;

        public const string CMD_ZOOM_POSITION = "SetZoomPosition";
        public const int CMD_ZOOM_POSITION_SPEED_MAX = 4;
        public const int CMD_ZOOM_POSITION_SPEED_STOP = 0;
        public const int CMD_ZOOM_POSITION_MAX = 10;
        public const int CMD_ZOOM_POSITION_MIN = 1;

        public const int PRESET_MAX = 100;

        public const string MESSAGE_CHECK_CAMERA_STATUS = "接続できません。カメラの状態を確認してください";
        public const string MESSAGE_AUTH_ERROR = "認証に失敗しました。ユーザー名とパスワードを確認してください";
        public const string MESSAGE_CONFIRM_REGIST = "接続先に登録しますか";
        public const string MESSAGE_CHECK = "確認";
        public const string MESSAGE_CONFIRM_QUIT = "受信中のカメラがあります。終了しますか？";

        // 画面の高さ、幅
        public const int SCREEN_WIDTH = 640;                   // 画面の幅
        public const int SCREEN_HEIGHT = 360;                  // 画面の高さ

        // サムネイルの高さ、幅
        public const int THUMB_WIDTH = SCREEN_WIDTH / 4;       // サムネイルの幅
        public const int THUMB_HEIGHT = SCREEN_HEIGHT / 4;     // サムネイルの高さ


        ////// スレッドからフォームを更新するための処理 ////
        //private delegate void D_UpdText();

        //private void UpdText() {
        //    label1.Text = receivedData + "byte受信";
        //    label2.Text = previousReceivedData +"";
        //    label1.Update();
        //}
        ////////////////////////////////////////////////////


    }
}
