﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX.DirectInput;

namespace WindowsFormsApplication1
{
    public partial class padSetting : Form
    {
        public int sJ;
        public int sK;
        public Device jS;

        ///// Form1の値を他のフォームから呼び出すための記述 /////
        private static padSetting _padInstance;

        public static padSetting PadInstance { get { return _padInstance; } set { _padInstance = value; } }

        // パンチルト加速に割り当てるボタン番号
        public int pad_PanTilt_Up{ get { return (int) numeric_PanTilt_Up.Value; } set { numeric_PanTilt_Up.Value = (decimal)value; } }
        
        // パンチルト減速に割り当てるボタン番号
        public int pad_PanTilt_Down { get { return (int)numeric_PanTilt_Down.Value; } set { numeric_PanTilt_Down.Value = (decimal)value; } }
        
        // Tズームに割り当てるボタン番号
        public int pad_T_Zoom { get { return (int)numeric_T_Zoom.Value; } set { numeric_T_Zoom.Value = (decimal)value; } }

        // Wズームに割り当てるボタン番号
        public int pad_W_Zoom { get { return (int)numeric_W_Zoom.Value; } set { numeric_W_Zoom.Value = (decimal)value;} }

        // センターリセットに割り当てるボタン番号  
        public int pad_Center_Reset { get { return (int)numeric_Center_Reset.Value; } set { numeric_Center_Reset.Value = (decimal)value; } }

        // パッドで押されたボタンのコード(番号)
        public int scannedKey { get { return sK; } set { sK = value; } }

        // 選択されているパッド (番号)
        public int selectedJoyStick { get { return sJ; } set { sJ = value; } }

        // 選択されているジョイスティック
        public Device joyStick { get { return jS; } set { jS = value; } }


        public padSetting()
        {
            InitializeComponent();
            padSetting.PadInstance = this;
        }

        private void padSetting_Load(object sender, EventArgs e)    // フォームロードと同時に接続されているパッドを読み込む
        {
            numeric_PanTilt_Up.Value = (decimal) MainForm.Form1Instance.padKeys.PanTilt_Up;
            numeric_PanTilt_Down.Value = (decimal)MainForm.Form1Instance.padKeys.PanTilt_Down;
            numeric_T_Zoom.Value = (decimal)MainForm.Form1Instance.padKeys.T_Zoom;
            numeric_W_Zoom.Value = (decimal)MainForm.Form1Instance.padKeys.W_Zoom;
            numeric_Center_Reset.Value = (decimal)MainForm.Form1Instance.padKeys.Center_Reset;

            joyPadClass joypadC = new joyPadClass();    //
            Device joyStick;
            int num_of_joyStick;

            num_of_joyStick = joypadC.getNumber();

            for (int i = 0; i < num_of_joyStick; i++)
            {
                joyStick = joypadC.getJoyPad(i,this.Handle);
                comboBox_JoyPadName.Items.Add(joyStick.DeviceInformation.InstanceName);
            }
            if (comboBox_JoyPadName.Items.Count > 0 ) {
                comboBox_JoyPadName.SelectedIndex = 0;
            }
        }

        private void comboBox_JoyPadName_SelectedIndexChanged(object sender, EventArgs e)   // コンボボックスで選択しているパッドが変更されたときの処理
        {
            joyPadClass joypadC = new joyPadClass();
            selectedJoyStick = comboBox_JoyPadName.SelectedIndex;
            joyStick = joypadC.getJoyPad(selectedJoyStick,this.Handle);
        }

        private void button_PanTilt_Up_Click(object sender, EventArgs e)
        {
            if (comboBox_JoyPadName.SelectedIndex >= 0)
            {
                padScan pS = new padScan();
                pS.ShowDialog();

                if (scannedKey >= 0)
                {
                    numeric_PanTilt_Up.Value = (decimal)scannedKey;
                }
            }
        }

        private void button_PanTilt_Down_Click(object sender, EventArgs e)
        {
            if (comboBox_JoyPadName.SelectedIndex >=0)
            {
                padScan pS = new padScan();
                pS.ShowDialog();

                if (scannedKey >= 0)
                {
                    numeric_PanTilt_Down.Value = (decimal)scannedKey;
                }
            }
        }

        private void button_T_Zoom_Click(object sender, EventArgs e)
        {
            if (comboBox_JoyPadName.SelectedIndex >= 0)
            {

                padScan pS = new padScan();
                pS.ShowDialog();

                if (scannedKey >= 0)
                {
                    numeric_T_Zoom.Value = (decimal)scannedKey;
                }
            }
        }

        private void button_W_Zoom_Click(object sender, EventArgs e)
        {
            if (comboBox_JoyPadName.SelectedIndex >= 0)
            {
                padScan pS = new padScan();
                pS.ShowDialog();

                if (scannedKey >= 0)
                {
                    numeric_W_Zoom.Value = (decimal)scannedKey;
                }
            }
        }


        private void button_Center_Reset_Click(object sender, EventArgs e)
        {
            if (comboBox_JoyPadName.SelectedIndex >= 0)
            {
                padScan pS = new padScan();
                pS.ShowDialog();

                if (scannedKey >= 0)
                {
                    numeric_Center_Reset.Value = (decimal)scannedKey;
                }
            }

        }


        private void padSetting_FormClosing(object sender, FormClosingEventArgs e)
        {
            pads pk = new pads();

            pk.gamePad = comboBox_JoyPadName.SelectedIndex;
            pk.PanTilt_Up = pad_PanTilt_Up;
            pk.PanTilt_Down = pad_PanTilt_Down;
            pk.T_Zoom = pad_T_Zoom;
            pk.W_Zoom = pad_W_Zoom;
            pk.Center_Reset = pad_Center_Reset;

            MainForm.Form1Instance.padKeys = pk;

        }





    }
}
