﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class presetEdit : Form
    {
        private int selectedIndex;
        private string selectedText;
        private PresetData_with_Name pre_data;


        public presetEdit()
        {
            InitializeComponent();
        }

        private void presetEdit_Load(object sender, EventArgs e)
        {
            selectedIndex = MainForm.Form1Instance.selectedPresetIndex;
            selectedText = MainForm.Form1Instance.selectedPresetText;
            pre_data = MainForm.Form1Instance.preset_data[selectedIndex];

            textBox_PresetName.Text = selectedText;
            numericUpDown_Pan.Value  = (decimal) pre_data.PanPosition;
            numericUpDown_Tilt.Value = (decimal) pre_data.TiltPosition;
            numericUpDown_Zoom.Value = (decimal) (((double)(pre_data.DeciZoomPosition)) /10);
        }

        private void button_Save_Click(object sender, EventArgs e)
        {
            pre_data.Name = textBox_PresetName.Text;

            pre_data.PanPosition = (int) numericUpDown_Pan.Value;
            pre_data.TiltPosition = (int) numericUpDown_Tilt.Value;
            pre_data.DeciZoomPosition = (int)((decimal) numericUpDown_Zoom.Value * 10);
            MainForm.Form1Instance.selectedPresetText = textBox_PresetName.Text;
            MainForm.Form1Instance.preset_data[selectedIndex] = pre_data;
            this.Dispose();
        }

        private void button_Cancel_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

    }


    //
    class presetClass
    {

        // それぞれの値をまとめて、PresetDada形式に変換する関数
        public PresetData_without_Name returnPresetData_without_Name(bool PantiltValid_, int PanPosition_, int TiltPosition_, int DeciZoomPosition_)
        {

            PresetData_without_Name p = new PresetData_without_Name();

            p.PanTiltValid = PantiltValid_;
            p.PanPosition = PanPosition_;
            p.TiltPosition = TiltPosition_;
            p.DeciZoomPosition = DeciZoomPosition_;

            return p;
        }

        // それぞれの値をまとめて、PresetDada形式に変換する関数
        public PresetData_with_Name returnPresetData_with_Name(bool PantiltValid_, int PanPosition_, int TiltPosition_, int DeciZoomPosition_, string Name_)
        {

            PresetData_with_Name p = new PresetData_with_Name();

            p.PanTiltValid = PantiltValid_;
            p.PanPosition = PanPosition_;
            p.TiltPosition = TiltPosition_;
            p.DeciZoomPosition = DeciZoomPosition_;
            p.Name = Name_;

            return p;
        }


        // プリセットデータを削除する関数
        public void deletePreset(int selected_)
        {
            if (selected_ > 0)
            {
                for (int j = selected_; j < MainForm.Form1Instance.num_of_preset_data; j++)
                {
                    MainForm.Form1Instance.preset_data[j] = MainForm.Form1Instance.preset_data[j + 1];
                }
                MainForm.Form1Instance.presetList.Items.RemoveAt(selected_);
                MainForm.Form1Instance.preset_data[MainForm.Form1Instance.num_of_preset_data] = returnPresetData_with_Name(false, 0, 0, 0, "");
                MainForm.Form1Instance.num_of_preset_data = MainForm.Form1Instance.num_of_preset_data - 1;
            }
        }

    }






}
