﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace WindowsFormsApplication1
{
    class ptzClass
    {

        // パンチルトコマンドの送信関数(外部からたたく場合はこちらを使う)
        public void postPTCommand(int Cmd_, int pan_, int tilt_, bool inverse)
        {
            int selectedCamera = MainForm.Form1Instance.selectedCamera;
            postPTCommand(MainForm.Form1Instance.cameraSettings[selectedCamera].ipAddress,
                            int.Parse(MainForm.Form1Instance.cameraSettings[selectedCamera].portNumber),
                            Cmd_, pan_, tilt_, inverse, 
                            MainForm.Form1Instance.cookieContainers[selectedCamera],
                            MainForm.Form1Instance.cameraSettings[selectedCamera].useProxy);
        }

        // ズームコマンドの送信関数(外部からたたく場合はこちらを使う)
        public void postZoomCommand(int zoom_)
        {
            int selectedCamera = MainForm.Form1Instance.selectedCamera;
            postZoomCommand(MainForm.Form1Instance.cameraSettings[selectedCamera].ipAddress,
                            int.Parse(MainForm.Form1Instance.cameraSettings[selectedCamera].portNumber),
                            zoom_, 
                            MainForm.Form1Instance.cookieContainers[selectedCamera],
                            MainForm.Form1Instance.cameraSettings[selectedCamera].useProxy);
        }

        // ズームコマンドの送信関数(ズーム位置を直接指定版)(外部から叩く場合はこちらを使う)
        public void postZoomPositionCommand(int zoom_, int speed_)
        {
            int selectedCamera = MainForm.Form1Instance.selectedCamera;
            postZoomPositionCommand(MainForm.Form1Instance.cameraSettings[selectedCamera].ipAddress,
                            int.Parse(MainForm.Form1Instance.cameraSettings[selectedCamera].portNumber), 
                            zoom_, speed_,
                            MainForm.Form1Instance.cookieContainers[selectedCamera],
                            MainForm.Form1Instance.cameraSettings[selectedCamera].useProxy);
        }


        // 通常外部からは使わない //////////////////////////////////////
        // パンチルト操作コマンドを送る関数
        private void postPTCommand(string ipAddr, int portNum, int Cmd_, int pan_, int tilt_, bool inverse, CookieContainer cookie_, bool useProxy)
        {
            Thread thButton = new Thread(delegate()
            {
                httpClass htC = new httpClass();
                JSON_Commands jsonC = new JSON_Commands();

                int cmd = Cmd_;
                int pan = pan_;
                int tilt = tilt_;

                // Cmdが0の場合は、PanとTiltの値を反転させる、Cmdが0以外の場合はCmdを反転させる
                if (inverse == true)
                {
                    if (cmd == 0)
                    {
                        pan = pan * -1;
                        tilt = tilt * -1;
                    }
                    else
                    {
                        cmd = cmd * -1;
                    }
                }
                htC.postStream("http://" + ipAddr + ":" + portNum + httpClass.URL_SEND_COMMAND, jsonC.SetPTCtrl(cmd, pan, tilt), cookie_,useProxy);
            });
            thButton.Start();
        }


        // ズームコマンドの送信関数
        private void postZoomCommand(string ipAddr, int portNum, int zoom_, CookieContainer cookie_,bool useProxy)
        {
            Thread thButton = new Thread(delegate()
            {
                httpClass htC = new httpClass();
                JSON_Commands jsonC = new JSON_Commands();

                string ctrl = constClass.Ctrl_WideEnd;

                switch (zoom_){
                    case 3:
                        ctrl = constClass.Ctrl_TeleBegin3;
                        break;
                    case 2:
                        ctrl = constClass.Ctrl_TeleBegin2;
                        break;
                    case 1:
                        ctrl = constClass.Ctrl_TeleBegin1;
                        break;
                    case 0:
                        ctrl = constClass.Ctrl_WideEnd;
                        break;
                    case -1:
                        ctrl = constClass.Ctrl_WideBegin1;
                        break;
                    case -2:
                        ctrl = constClass.Ctrl_WideBegin2;
                        break;
                    case -3:
                        ctrl = constClass.Ctrl_WideBegin3;
                        break;
                    default:
                        ctrl = constClass.Ctrl_WideEnd;
                        break;
                }

                htC.postStream("http://" + ipAddr + ":" + portNum + httpClass.URL_SEND_COMMAND, jsonC.SetCAMCtrl(ctrl), cookie_, useProxy);

            });
            thButton.Start();
        }


        // ズームコマンドの送信関数(ズーム位置を直接指定版)
        private void postZoomPositionCommand(string ipAddr, int portNum, int zoom_, int speed_, CookieContainer cookie_,bool useProxy)
        {
            Thread thButton = new Thread(delegate()
            {
                httpClass htC = new httpClass();
                JSON_Commands jsonC = new JSON_Commands();
                htC.postStream("http://" + ipAddr + ":" + portNum + httpClass.URL_SEND_COMMAND, jsonC.SetZoomPosition(zoom_, speed_), cookie_,useProxy);
            });
            thButton.Start();
        }





    }
}
