﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class settingWindow : Form
    {
        public const string SETTING_PORT_NUMBER = "8000";

        public settingWindow()
        {
            InitializeComponent();
        }


        private void webBrowser1_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            string ip = MainForm.Form1Instance.cameraSettings[MainForm.Form1Instance.selectedCamera].ipAddress;
            string port = SETTING_PORT_NUMBER;
            string url = "http://" + ip + ":" + port + httpClass.URL_FINISH_SESSION;

            if (webBrowser1.Url.ToString() == url) {
                if (this.IsDisposed != true)
                {
                    this.Dispose();
                }
            } 
        }


        private void settingWindow_Load(object sender, EventArgs e)
        {
            int IEver;
            IEver = webBrowser1.Version.Major;  // Webブラウザからメジャーバージョンを取得する

            if (IEver < 8)
            {
                MessageBox.Show("IEのバージョンが古すぎます。IE8以降を使用してください。");
                this.Dispose();
            }
            else {
                string user = MainForm.Form1Instance.cameraSettings[MainForm.Form1Instance.selectedCamera].userName;
                string pass = MainForm.Form1Instance.cameraSettings[MainForm.Form1Instance.selectedCamera].passWord;
                string ip = MainForm.Form1Instance.cameraSettings[MainForm.Form1Instance.selectedCamera].ipAddress;
                string port = SETTING_PORT_NUMBER;
                string url = "http://" + user + ":" + pass + "@" + ip + ":" + port + "/";
                // string url = "http://" + ip + ":" + port;
                webBrowser1.Navigate(url);
            }
        }

        private void settingWindow_FormClosing(object sender, FormClosingEventArgs e)
        {
            string ip = MainForm.Form1Instance.cameraSettings[MainForm.Form1Instance.selectedCamera].ipAddress;
            string port = SETTING_PORT_NUMBER;
            string url = "http://" + ip + ":" + port + httpClass.URL_FINISH_SESSION;

            if (this.IsDisposed != true & webBrowser1 != null)
            {
                if (webBrowser1.Url != null)
                {
                    if (webBrowser1.Url.ToString() != url)
                    {
                        webBrowser1.Navigate(url);
                    }
                }
            }
        }



    }
}
