﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;

namespace WindowsFormsApplication1
{
    class xmlClass
    {

        // 設定ファイルの読み込み
        public int readSetting(string fileName)
        {

            if (File.Exists(fileName) == true)
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(fileName);
                XmlNode root = doc.DocumentElement;
                XmlNode xNode;
                XmlNodeList nodeList;
                XmlAttribute attC;


                nodeList = root.SelectNodes("/setting/DIST_IP1");   // IPアドレスの読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].ipAddress = ((XmlElement)xNode).InnerText;
                }


                nodeList = root.SelectNodes("/setting/DIST_PORT1"); // ポート番号の読み取り                
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].portNumber = ((XmlElement)xNode).InnerText;
                }


                nodeList = root.SelectNodes("/setting/INVERSE_PICTURE"); // 画面反転フラグの読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    if (((XmlElement)xNode).InnerText == "1") {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].inversePicture = true;
                    } else {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].inversePicture = false;
                    }
                }

                nodeList = root.SelectNodes("/setting/PLAY_SOUND"); // 音声出力フラグの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    if (((XmlElement)xNode).InnerText == "1")
                    {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].playSound = true;
                    }
                    else
                    {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].playSound = false;
                    }
                }

                nodeList = root.SelectNodes("/setting/USER1"); // ユーザー名の読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].userName = reverseString(randomAppend_Delete(Encoding.UTF8.GetString(Convert.FromBase64String(((XmlElement)xNode).InnerText)), false));
                }

                nodeList = root.SelectNodes("/setting/PASS1"); // パスワードの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].passWord = reverseString(randomAppend_Delete(Encoding.UTF8.GetString(Convert.FromBase64String(((XmlElement)xNode).InnerText)), false));
                }

                nodeList = root.SelectNodes("/setting/USE_SYSTEM_PROXY1"); // プロキシ使用フラグの読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];

                    if (((XmlElement)xNode).InnerText == "1") {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].useProxy = true;
                    } else {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].useProxy = false;
                    }
                }

                nodeList = root.SelectNodes("/setting/OVERLAY_STRING1"); // 文字重畳フラグの読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];

                    if (((XmlElement)xNode).InnerText == "1") {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].overlayString = true;
                    } else {
                        MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].overlayString = false;
                    }
                }

                nodeList = root.SelectNodes("/setting/OVERLAY_STRING_DATA1"); // 文字重畳フラグの読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    attC = xNode.Attributes[0];
                    MainForm.Form1Instance.cameraSettings[int.Parse(attC.InnerXml)].overlayStringData = ((XmlElement)xNode).InnerText;
                }

                try
                {
                    xNode = root.SelectSingleNode("ZOOM_SPEED");    // ズームスピードの読み取り
                    MainForm.Form1Instance.zoom_Speed = int.Parse(((XmlElement)xNode).InnerText);

                    xNode = root.SelectSingleNode("PANTILT_SPEED"); // パンチルトスピードの読み取り
                    MainForm.Form1Instance.pantilt_Speed = int.Parse(((XmlElement)xNode).InnerText);

                    // パッド設定の読み取り
                    pads pk;
                    xNode = root.SelectSingleNode("SELECTED_PAD");
                    pk.gamePad = int.Parse(xNode.InnerText);
                    xNode = root.SelectSingleNode("PADKEY_PANTILT_UP");
                    pk.PanTilt_Up = int.Parse(xNode.InnerText);
                    xNode = root.SelectSingleNode("PADKEY_PANTILT_DOWN");
                    pk.PanTilt_Down = int.Parse(xNode.InnerText);
                    xNode = root.SelectSingleNode("PADKEY_T_ZOOM");
                    pk.T_Zoom = int.Parse(xNode.InnerText);
                    xNode = root.SelectSingleNode("PADKEY_W_ZOOM");
                    pk.W_Zoom = int.Parse(xNode.InnerText);
                    xNode = root.SelectSingleNode("PADKEY_CENTER_RESET");
                    pk.Center_Reset = int.Parse(xNode.InnerText);
                    MainForm.Form1Instance.padKeys = pk;
                }
                catch { 
                
                }

            }
            else
            {   
                return -1;
            }

            return 0;
        }


        // 設定ファイルの書き込み //
        public int writeSetting(string fileName)
        {
            XmlDocument doc = new XmlDocument();
            XmlDeclaration decla = doc.CreateXmlDeclaration("1.0", "UTF-8", null);
            XmlNode root = doc.CreateElement("setting");
            XmlElement element;
            
            doc.AppendChild(decla);
            doc.AppendChild(root);

            // 各設定値の保存

            // パンチルト・ズームボタン
            element = doc.CreateElement("ZOOM_SPEED");      // ズームスピード
            element.InnerText = MainForm.Form1Instance.zoom_Speed.ToString();
            root.AppendChild(element);
            element = doc.CreateElement("PANTILT_SPEED");   // パンチルトスピード
            element.InnerText = MainForm.Form1Instance.pantilt_Speed.ToString();
            root.AppendChild(element);

            // パッド関連
            element = doc.CreateElement("SELECTED_PAD");    // 使用するゲームパッド(の番号)
            element.InnerText = MainForm.Form1Instance.padKeys.gamePad.ToString();
            root.AppendChild(element);
            element = doc.CreateElement("PADKEY_PANTILT_UP");   // パンチルト加速のキー
            element.InnerText = MainForm.Form1Instance.padKeys.PanTilt_Up.ToString();
            root.AppendChild(element);
            element = doc.CreateElement("PADKEY_PANTILT_DOWN"); // パンチルト減速のキー
            element.InnerText = MainForm.Form1Instance.padKeys.PanTilt_Down.ToString();
            root.AppendChild(element);
            element = doc.CreateElement("PADKEY_T_ZOOM");   // Tズームのキー
            element.InnerText = MainForm.Form1Instance.padKeys.T_Zoom.ToString();
            root.AppendChild(element);
            element = doc.CreateElement("PADKEY_W_ZOOM");   // Wズームのキー
            element.InnerText = MainForm.Form1Instance.padKeys.W_Zoom.ToString();
            root.AppendChild(element);
            element = doc.CreateElement("PADKEY_CENTER_RESET"); // センターリセットのキー
            element.InnerText = MainForm.Form1Instance.padKeys.Center_Reset.ToString();
            root.AppendChild(element);

            for (int i = 0; i < MainForm.Form1Instance.cameraSettings.Count(); i++)
            {

                element = doc.CreateElement("INVERSE_PICTURE"); // 画面反転フラグ
                if (MainForm.Form1Instance.cameraSettings[i].inversePicture == true)
                {
                    element.InnerText = "1";
                }
                else
                {
                    element.InnerText = "0";
                }
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("PLAY_SOUND");  // 音声出力フラグ
                if (MainForm.Form1Instance.cameraSettings[i].playSound == true)
                {
                    element.InnerText = "1";
                }
                else
                {
                    element.InnerText = "0";
                }
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("USER1");   // ユーザー名
                element.InnerText = Convert.ToBase64String(Encoding.UTF8.GetBytes(randomAppend_Delete(reverseString(MainForm.Form1Instance.cameraSettings[i].userName), true)));
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("PASS1");   // パスワード
                element.InnerText = Convert.ToBase64String(Encoding.UTF8.GetBytes(randomAppend_Delete(reverseString(MainForm.Form1Instance.cameraSettings[i].passWord), true)));
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("DIST_IP1");    // IPアドレス
                element.InnerText = MainForm.Form1Instance.cameraSettings[i].ipAddress;
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);
                
                element = doc.CreateElement("DIST_PORT1");  // ポート
                element.InnerText = MainForm.Form1Instance.cameraSettings[i].portNumber;
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("USE_SYSTEM_PROXY1");   // プロキシ使用フラグ
                if (MainForm.Form1Instance.cameraSettings[i].useProxy == true) {
                    element.InnerText = "1";
                }
                else {
                    element.InnerText = "0";
                }
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("OVERLAY_STRING1"); // 文字重畳フラグ
                if (MainForm.Form1Instance.cameraSettings[i].overlayString == true) {
                    element.InnerText = "1";
                } else {
                    element.InnerText = "0";
                }
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

                element = doc.CreateElement("OVERLAY_STRING_DATA1");    // 重畳する文字
                element.InnerText = MainForm.Form1Instance.cameraSettings[i].overlayStringData;
                element.SetAttribute("CAMERA", i.ToString());
                root.AppendChild(element);

            }         

            doc.Save(fileName);

            return 0;
        }


        // プリセットファイルの読み込み //
        public int readPreset(string fileName)
        {
            if (File.Exists(fileName) == true)
            {
                XmlDocument doc = new XmlDocument();
                XmlNode root,node;
                XmlNodeList nodeList;
                XmlAttributeCollection attC;

                doc.Load(fileName);
                root = doc.DocumentElement;
                nodeList = root.SelectNodes("/preset/PRESET");

                int count = nodeList.Count;
                MainForm.Form1Instance.num_of_preset_data = count;

                for (int i = 1; i <= count; i++) {

                    node = nodeList[i-1];
                    MainForm.Form1Instance.presetList_Add = ((XmlElement)node).InnerText;
                    MainForm.Form1Instance.preset_data[i].Name = ((XmlElement)node).InnerText;
                    attC = node.Attributes;

                    for (int j = 0; j < attC.Count; j++)
                    {
                        switch (attC[j].Name)
                        {   
                            case "PanTiltValid":
                                if (attC[j].InnerXml == "1") {
                                    MainForm.Form1Instance.preset_data[i].PanTiltValid = true;
                                } else {
                                    MainForm.Form1Instance.preset_data[i].PanTiltValid = false;
                                }
                                break;
                            case "PanPosition":
                                MainForm.Form1Instance.preset_data[i].PanPosition = int.Parse(attC[j].InnerXml);
                                break;
                            case "TiltPosition":
                                MainForm.Form1Instance.preset_data[i].TiltPosition = int.Parse(attC[j].InnerXml);
                                break;
                            case "DeciZoomPosition":
                                MainForm.Form1Instance.preset_data[i].DeciZoomPosition = int.Parse(attC[j].InnerXml);
                                break;                        
                        }
                    }
                }
                return 0;
            }
            else {
                return -1;
            }

        }


        // プリセットファイルの書き込み
        public int writePreset(string fileName)
        {
            int count = MainForm.Form1Instance.presetList.Items.Count;
            string name;

            PresetData_with_Name p = new PresetData_with_Name();

            XmlDocument doc = new XmlDocument();
            XmlDeclaration decla = doc.CreateXmlDeclaration("1.0", "UTF-8", null);
            XmlNode root = doc.CreateElement("preset");
            XmlElement element;

            doc.AppendChild(decla);
            doc.AppendChild(root);

            for (int i = 1; i < count; i++) {
                name = (string) MainForm.Form1Instance.presetList.Items[i];

                element = doc.CreateElement("PRESET");
                element.InnerText = name;

                p.PanTiltValid = MainForm.Form1Instance.preset_data[i].PanTiltValid;
                p.PanPosition = MainForm.Form1Instance.preset_data[i].PanPosition;
                p.TiltPosition = MainForm.Form1Instance.preset_data[i].TiltPosition;
                p.DeciZoomPosition = MainForm.Form1Instance.preset_data[i].DeciZoomPosition;

                if (p.PanTiltValid == true)
                {
                    element.SetAttribute("PanTiltValid", "1");
                }
                else {
                    element.SetAttribute("PanTiltValid", "0");                
                }
                
                element.SetAttribute("PanPosition",p.PanPosition.ToString());
                element.SetAttribute("TiltPosition", p.TiltPosition.ToString());
                element.SetAttribute("DeciZoomPosition",p.DeciZoomPosition.ToString());

                root.AppendChild(element);

            }

            doc.Save(fileName);

            return 0;
        }




        // 文字列の順序をひっくり返す関数 
        private string reverseString(string instr_) {
            string tmp ="";

            for (int i = instr_.Length-1 ; i >= 0; i--) {
                tmp = tmp + instr_.Substring(i, 1);  
            }

            return tmp;
        }


        // 文字列にランダムな値を入れる関数
        private string randomAppend_Delete(string instr_, bool append) {
            string tmp = "";
            int randomNumber;

            Random rnd = new Random();

            if (append == true)
            {   
                // ランダム値追加モード (奇数番目に数値を挿入)
                for (int i = 0; i < instr_.Length; i++)
                {
                    randomNumber = rnd.Next(10);
                    tmp = tmp + randomNumber + instr_.Substring(i, 1);
                }
            } else { 
                
                //値削除モード (奇数番目の文字を取り除く)
                for (int i = 0; i < (instr_.Length/2); i++) {
                    tmp = tmp + instr_.Substring(1 + 2 * i, 1);
                }
            }
             
            return tmp;
        }



    }
}
